// wrapstrings.cpp
// This file is generated by Shroud 0.12.1. Do not edit.
// Copyright (c) 2017-2020, Lawrence Livermore National Security, LLC and
// other Shroud Project Developers.
// See the top-level COPYRIGHT file for details.
//
// SPDX-License-Identifier: (BSD-3-Clause)
//
#include "wrapstrings.h"
#include <cstddef>
#include <cstdlib>
#include <cstring>
#include <string>
#include "strings.hpp"
#include "typesstrings.h"

// splicer begin CXX_definitions
// splicer end CXX_definitions

extern "C" {


// helper ShroudStrAlloc
// Copy src into new memory and null terminate.
static char *ShroudStrAlloc(const char *src, int nsrc, int ntrim)
{
   char *rv = (char *) std::malloc(nsrc + 1);
   if (ntrim > 0) {
     std::memcpy(rv, src, ntrim);
   }
   rv[ntrim] = '\0';
   return rv;
}

// helper ShroudStrBlankFill
// blank fill dest starting at trailing NULL.
static void ShroudStrBlankFill(char *dest, int ndest)
{
   int nm = std::strlen(dest);
   if(ndest > nm) std::memset(dest+nm,' ',ndest-nm);
}

// helper ShroudStrCopy
// Copy src into dest, blank fill to ndest characters
// Truncate if dest is too short.
// dest will not be NULL terminated.
static void ShroudStrCopy(char *dest, int ndest, const char *src, int nsrc)
{
   if (src == NULL) {
     std::memset(dest,' ',ndest); // convert NULL pointer to blank filled string
   } else {
     if (nsrc < 0) nsrc = std::strlen(src);
     int nm = nsrc < ndest ? nsrc : ndest;
     std::memcpy(dest,src,nm);
     if(ndest > nm) std::memset(dest+nm,' ',ndest-nm); // blank fill
   }
}

// helper ShroudStrFree
// Release memory allocated by ShroudStrAlloc
static void ShroudStrFree(char *src)
{
   free(src);
}

// start helper ShroudStrToArray
// helper ShroudStrToArray
// Save str metadata into array to allow Fortran to access values.
// CHARACTER(len=elem_size) src
static void ShroudStrToArray(STR_SHROUD_array *array, const std::string * src, int idtor)
{
    array->cxx.addr = const_cast<std::string *>(src);
    array->cxx.idtor = idtor;
    if (src->empty()) {
        array->addr.ccharp = NULL;
        array->elem_len = 0;
    } else {
        array->addr.ccharp = src->data();
        array->elem_len = src->length();
    }
    array->size = 1;
    array->rank = 0;  // scalar
}
// end helper ShroudStrToArray
// splicer begin C_definitions
// splicer end C_definitions

/**
 * \brief pass a single char argument as a scalar.
 *
 */
// ----------------------------------------
// Function:  void passChar
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char status +intent(in)+value
// Exact:     c_char_scalar_in
void STR_pass_char(char status)
{
    // splicer begin function.pass_char
    passChar(status);
    // splicer end function.pass_char
}

/**
 * By default no Fortran wrapper is created.
 * Force one so it can be tested.
 */
// ----------------------------------------
// Function:  void passCharForce
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char status +intent(in)+value
// Exact:     c_char_scalar_in
void STR_pass_char_force(char status)
{
    // splicer begin function.pass_char_force
    passCharForce(status);
    // splicer end function.pass_char_force
}

/**
 * \brief return a char argument (non-pointer)
 *
 */
// ----------------------------------------
// Function:  char returnChar
// Exact:     c_char_scalar_result
char STR_return_char(void)
{
    // splicer begin function.return_char
    char SHC_rv = returnChar();
    return SHC_rv;
    // splicer end function.return_char
}

/**
 * \brief return a char argument (non-pointer)
 *
 */
// ----------------------------------------
// Function:  void returnChar
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  char * SHF_rv +intent(out)+len(NSHF_rv)
// Exact:     c_char_scalar_result_buf
void STR_return_char_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.return_char_bufferify
    char SHC_rv = returnChar();
    std::memset(SHF_rv, ' ', NSHF_rv);
    SHF_rv[0] = SHC_rv;
    // splicer end function.return_char_bufferify
}

/**
 * \brief strcpy like behavior
 *
 * dest is marked intent(OUT) to override the intent(INOUT) default
 * This avoid a copy-in on dest.
 * In Python, src must not be over 40 characters, defined by charlen.
 */
// ----------------------------------------
// Function:  void passCharPtr
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * dest +charlen(40)+intent(out)
// Requested: c_char_*_out
// Match:     c_default
// ----------------------------------------
// Argument:  const char * src +intent(in)
// Requested: c_char_*_in
// Match:     c_default
// start STR_pass_char_ptr
void STR_pass_char_ptr(char * dest, const char * src)
{
    // splicer begin function.pass_char_ptr
    passCharPtr(dest, src);
    // splicer end function.pass_char_ptr
}
// end STR_pass_char_ptr

/**
 * \brief strcpy like behavior
 *
 * dest is marked intent(OUT) to override the intent(INOUT) default
 * This avoid a copy-in on dest.
 * In Python, src must not be over 40 characters, defined by charlen.
 */
// ----------------------------------------
// Function:  void passCharPtr
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * dest +charlen(40)+intent(out)+len(Ndest)
// Exact:     c_char_*_out_buf
// ----------------------------------------
// Argument:  const char * src +intent(in)
// Requested: c_char_*_in
// Match:     c_default
// start STR_pass_char_ptr_bufferify
void STR_pass_char_ptr_bufferify(char * dest, int Ndest,
    const char * src)
{
    // splicer begin function.pass_char_ptr_bufferify
    passCharPtr(dest, src);
    ShroudStrBlankFill(dest, Ndest);
    // splicer end function.pass_char_ptr_bufferify
}
// end STR_pass_char_ptr_bufferify

/**
 * \brief toupper
 *
 * Change a string in-place.
 * For Python, return a new string since strings are immutable.
 */
// ----------------------------------------
// Function:  void passCharPtrInOut
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * s +intent(inout)
// Requested: c_char_*_inout
// Match:     c_default
void STR_pass_char_ptr_in_out(char * s)
{
    // splicer begin function.pass_char_ptr_in_out
    passCharPtrInOut(s);
    // splicer end function.pass_char_ptr_in_out
}

/**
 * \brief toupper
 *
 * Change a string in-place.
 * For Python, return a new string since strings are immutable.
 */
// ----------------------------------------
// Function:  void passCharPtrInOut
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * s +intent(inout)+len(Ns)+len_trim(Ls)
// Exact:     c_char_*_inout_buf
void STR_pass_char_ptr_in_out_bufferify(char * s, int Ls, int Ns)
{
    // splicer begin function.pass_char_ptr_in_out_bufferify
    char * SHCXX_s = ShroudStrAlloc(s, Ns, Ls);
    passCharPtrInOut(SHCXX_s);
    ShroudStrCopy(s, Ns, SHCXX_s, -1);
    ShroudStrFree(SHCXX_s);
    // splicer end function.pass_char_ptr_in_out_bufferify
}

/**
 * \brief return a 'const char *' as character(*)
 *
 */
// ----------------------------------------
// Function:  const char * getCharPtr1 +deref(allocatable)
// Exact:     c_char_*_result
// start STR_get_char_ptr1
const char * STR_get_char_ptr1(void)
{
    // splicer begin function.get_char_ptr1
    const char * SHC_rv = getCharPtr1();
    return SHC_rv;
    // splicer end function.get_char_ptr1
}
// end STR_get_char_ptr1

/**
 * \brief return a 'const char *' as character(*)
 *
 */
// ----------------------------------------
// Function:  void getCharPtr1
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const char * SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)
// Exact:     c_char_*_result_buf_allocatable
// start STR_get_char_ptr1_bufferify
void STR_get_char_ptr1_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_char_ptr1_bufferify
    const char * SHC_rv = getCharPtr1();
    DSHF_rv->cxx.addr = const_cast<char *>(SHC_rv);
    DSHF_rv->cxx.idtor = 0;
    DSHF_rv->addr.ccharp = SHC_rv;
    DSHF_rv->type = SH_TYPE_OTHER;
    DSHF_rv->elem_len = SHC_rv == nullptr ? 0 : std::strlen(SHC_rv);
    DSHF_rv->size = 1;
    DSHF_rv->rank = 0;
    // splicer end function.get_char_ptr1_bufferify
}
// end STR_get_char_ptr1_bufferify

/**
 * \brief return 'const char *' with fixed size (len=30)
 *
 */
// ----------------------------------------
// Function:  const char * getCharPtr2 +deref(result-as-arg)+len(30)
// Exact:     c_char_*_result
// start STR_get_char_ptr2
const char * STR_get_char_ptr2(void)
{
    // splicer begin function.get_char_ptr2
    const char * SHC_rv = getCharPtr2();
    return SHC_rv;
    // splicer end function.get_char_ptr2
}
// end STR_get_char_ptr2

/**
 * \brief return 'const char *' with fixed size (len=30)
 *
 */
// ----------------------------------------
// Function:  void getCharPtr2 +len(30)
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  char * SHF_rv +intent(out)+len(NSHF_rv)
// Exact:     c_char_*_result_buf
// start STR_get_char_ptr2_bufferify
void STR_get_char_ptr2_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.get_char_ptr2_bufferify
    const char * SHC_rv = getCharPtr2();
    ShroudStrCopy(SHF_rv, NSHF_rv, SHC_rv, -1);
    // splicer end function.get_char_ptr2_bufferify
}
// end STR_get_char_ptr2_bufferify

/**
 * \brief return a 'const char *' as argument
 *
 */
// ----------------------------------------
// Function:  const char * getCharPtr3 +deref(result-as-arg)
// Exact:     c_char_*_result
// start STR_get_char_ptr3
const char * STR_get_char_ptr3(void)
{
    // splicer begin function.get_char_ptr3
    const char * SHC_rv = getCharPtr3();
    return SHC_rv;
    // splicer end function.get_char_ptr3
}
// end STR_get_char_ptr3

/**
 * \brief return a 'const char *' as argument
 *
 */
// ----------------------------------------
// Function:  void getCharPtr3
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  char * output +intent(out)+len(Noutput)
// Exact:     c_char_*_result_buf
// start STR_get_char_ptr3_bufferify
void STR_get_char_ptr3_bufferify(char * output, int Noutput)
{
    // splicer begin function.get_char_ptr3_bufferify
    const char * SHC_rv = getCharPtr3();
    ShroudStrCopy(output, Noutput, SHC_rv, -1);
    // splicer end function.get_char_ptr3_bufferify
}
// end STR_get_char_ptr3_bufferify

/**
 * \brief return a 'const char *' as type(C_PTR)
 *
 */
// ----------------------------------------
// Function:  const char * getCharPtr4 +deref(raw)
// Exact:     c_char_*_result
const char * STR_get_char_ptr4(void)
{
    // splicer begin function.get_char_ptr4
    const char * SHC_rv = getCharPtr4();
    return SHC_rv;
    // splicer end function.get_char_ptr4
}

/**
 * \brief return an ALLOCATABLE CHARACTER from std::string
 *
 */
// ----------------------------------------
// Function:  void getConstStringResult
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const string * SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)
// Exact:     c_string_scalar_result_buf_allocatable
void STR_get_const_string_result_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_result_bufferify
    std::string * SHCXX_rv = new std::string;
    *SHCXX_rv = getConstStringResult();
    ShroudStrToArray(DSHF_rv, SHCXX_rv, 1);
    // splicer end function.get_const_string_result_bufferify
}

/**
 * \brief return a 'const string' as argument
 *
 */
// ----------------------------------------
// Function:  void getConstStringLen +len(30)
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string * SHF_rv +intent(out)+len(NSHF_rv)
// Exact:     c_string_scalar_result_buf
void STR_get_const_string_len_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.get_const_string_len_bufferify
    const std::string SHCXX_rv = getConstStringLen();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(SHF_rv, NSHF_rv, nullptr, 0);
    } else {
        ShroudStrCopy(SHF_rv, NSHF_rv, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.get_const_string_len_bufferify
}

/**
 * \brief return a 'const string' as argument
 *
 */
// ----------------------------------------
// Function:  void getConstStringAsArg
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string * output +intent(out)+len(Noutput)
// Exact:     c_string_scalar_result_buf
void STR_get_const_string_as_arg_bufferify(char * output, int Noutput)
{
    // splicer begin function.get_const_string_as_arg_bufferify
    const std::string SHCXX_rv = getConstStringAsArg();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(output, Noutput, nullptr, 0);
    } else {
        ShroudStrCopy(output, Noutput, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.get_const_string_as_arg_bufferify
}

// ----------------------------------------
// Function:  void getConstStringAlloc
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)
// Exact:     c_string_scalar_result_buf_allocatable
void STR_get_const_string_alloc_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_alloc_bufferify
    std::string * SHCXX_rv = new std::string;
    *SHCXX_rv = getConstStringAlloc();
    ShroudStrToArray(DSHF_rv, SHCXX_rv, 1);
    // splicer end function.get_const_string_alloc_bufferify
}

/**
 * \brief return a 'const string&' as ALLOCATABLE character
 *
 */
// ----------------------------------------
// Function:  const string & getConstStringRefPure +deref(allocatable)
// Requested: c_string_&_result
// Match:     c_string_result
// start STR_get_const_string_ref_pure
const char * STR_get_const_string_ref_pure(void)
{
    // splicer begin function.get_const_string_ref_pure
    const std::string & SHCXX_rv = getConstStringRefPure();
    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ref_pure
}
// end STR_get_const_string_ref_pure

/**
 * \brief return a 'const string&' as ALLOCATABLE character
 *
 */
// ----------------------------------------
// Function:  void getConstStringRefPure
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const string & SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)
// Requested: c_string_&_result_buf_allocatable
// Match:     c_string_result_buf_allocatable
// start STR_get_const_string_ref_pure_bufferify
void STR_get_const_string_ref_pure_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_ref_pure_bufferify
    const std::string & SHCXX_rv = getConstStringRefPure();
    ShroudStrToArray(DSHF_rv, &SHCXX_rv, 0);
    // splicer end function.get_const_string_ref_pure_bufferify
}
// end STR_get_const_string_ref_pure_bufferify

/**
 * \brief return 'const string&' with fixed size (len=30)
 *
 * Since +len(30) is provided, the result of the function
 * will be copied directly into memory provided by Fortran.
 * The function will not be ALLOCATABLE.
 */
// ----------------------------------------
// Function:  const string & getConstStringRefLen +deref(result-as-arg)+len(30)
// Requested: c_string_&_result
// Match:     c_string_result
const char * STR_get_const_string_ref_len(void)
{
    // splicer begin function.get_const_string_ref_len
    const std::string & SHCXX_rv = getConstStringRefLen();
    // C_error_pattern
    if (SHCXX_rv.empty()) {
        return NULL;
    }

    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ref_len
}

/**
 * \brief return 'const string&' with fixed size (len=30)
 *
 * Since +len(30) is provided, the result of the function
 * will be copied directly into memory provided by Fortran.
 * The function will not be ALLOCATABLE.
 */
// ----------------------------------------
// Function:  void getConstStringRefLen +len(30)
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string & SHF_rv +intent(out)+len(NSHF_rv)
// Requested: c_string_&_result_buf
// Match:     c_string_result_buf
void STR_get_const_string_ref_len_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.get_const_string_ref_len_bufferify
    const std::string & SHCXX_rv = getConstStringRefLen();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(SHF_rv, NSHF_rv, nullptr, 0);
    } else {
        ShroudStrCopy(SHF_rv, NSHF_rv, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.get_const_string_ref_len_bufferify
}

/**
 * \brief return a 'const string&' as argument
 *
 * Pass an additional argument which wil be used as the return value.
 * The length of the output variable is declared by the caller.
 */
// ----------------------------------------
// Function:  const string & getConstStringRefAsArg +deref(result-as-arg)
// Requested: c_string_&_result
// Match:     c_string_result
const char * STR_get_const_string_ref_as_arg(void)
{
    // splicer begin function.get_const_string_ref_as_arg
    const std::string & SHCXX_rv = getConstStringRefAsArg();
    // C_error_pattern
    if (SHCXX_rv.empty()) {
        return NULL;
    }

    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ref_as_arg
}

/**
 * \brief return a 'const string&' as argument
 *
 * Pass an additional argument which wil be used as the return value.
 * The length of the output variable is declared by the caller.
 */
// ----------------------------------------
// Function:  void getConstStringRefAsArg
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string & output +intent(out)+len(Noutput)
// Requested: c_string_&_result_buf
// Match:     c_string_result_buf
void STR_get_const_string_ref_as_arg_bufferify(char * output,
    int Noutput)
{
    // splicer begin function.get_const_string_ref_as_arg_bufferify
    const std::string & SHCXX_rv = getConstStringRefAsArg();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(output, Noutput, nullptr, 0);
    } else {
        ShroudStrCopy(output, Noutput, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.get_const_string_ref_as_arg_bufferify
}

/**
 * \brief Test returning empty string reference
 *
 */
// ----------------------------------------
// Function:  const string & getConstStringRefLenEmpty +deref(result-as-arg)+len(30)
// Requested: c_string_&_result
// Match:     c_string_result
const char * STR_get_const_string_ref_len_empty(void)
{
    // splicer begin function.get_const_string_ref_len_empty
    const std::string & SHCXX_rv = getConstStringRefLenEmpty();
    // C_error_pattern
    if (SHCXX_rv.empty()) {
        return NULL;
    }

    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ref_len_empty
}

/**
 * \brief Test returning empty string reference
 *
 */
// ----------------------------------------
// Function:  void getConstStringRefLenEmpty +len(30)
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string & SHF_rv +intent(out)+len(NSHF_rv)
// Requested: c_string_&_result_buf
// Match:     c_string_result_buf
void STR_get_const_string_ref_len_empty_bufferify(char * SHF_rv,
    int NSHF_rv)
{
    // splicer begin function.get_const_string_ref_len_empty_bufferify
    const std::string & SHCXX_rv = getConstStringRefLenEmpty();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(SHF_rv, NSHF_rv, nullptr, 0);
    } else {
        ShroudStrCopy(SHF_rv, NSHF_rv, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.get_const_string_ref_len_empty_bufferify
}

// ----------------------------------------
// Function:  const std::string & getConstStringRefAlloc +deref(allocatable)
// Requested: c_string_&_result
// Match:     c_string_result
const char * STR_get_const_string_ref_alloc(void)
{
    // splicer begin function.get_const_string_ref_alloc
    const std::string & SHCXX_rv = getConstStringRefAlloc();
    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ref_alloc
}

// ----------------------------------------
// Function:  void getConstStringRefAlloc
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string & SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)
// Requested: c_string_&_result_buf_allocatable
// Match:     c_string_result_buf_allocatable
void STR_get_const_string_ref_alloc_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_ref_alloc_bufferify
    const std::string & SHCXX_rv = getConstStringRefAlloc();
    ShroudStrToArray(DSHF_rv, &SHCXX_rv, 0);
    // splicer end function.get_const_string_ref_alloc_bufferify
}

/**
 * \brief return a 'const string *' as character(30)
 *
 * It is the caller's responsibility to release the string
 * created by the C++ library.
 * This is accomplished with C_finalize_buf which is possible
 * because +len(30) so the contents are copied before returning.
 */
// ----------------------------------------
// Function:  const string * getConstStringPtrLen +deref(result-as-arg)+len(30)
// Requested: c_string_*_result
// Match:     c_string_result
const char * STR_get_const_string_ptr_len(void)
{
    // splicer begin function.get_const_string_ptr_len
    const std::string * SHCXX_rv = getConstStringPtrLen();
    const char * SHC_rv = SHCXX_rv->c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ptr_len
}

/**
 * \brief return a 'const string *' as character(30)
 *
 * It is the caller's responsibility to release the string
 * created by the C++ library.
 * This is accomplished with C_finalize_buf which is possible
 * because +len(30) so the contents are copied before returning.
 */
// ----------------------------------------
// Function:  void getConstStringPtrLen +len(30)
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  string * SHF_rv +intent(out)+len(NSHF_rv)
// Requested: c_string_*_result_buf
// Match:     c_string_result_buf
void STR_get_const_string_ptr_len_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.get_const_string_ptr_len_bufferify
    const std::string * SHCXX_rv = getConstStringPtrLen();
    if (SHCXX_rv->empty()) {
        ShroudStrCopy(SHF_rv, NSHF_rv, nullptr, 0);
    } else {
        ShroudStrCopy(SHF_rv, NSHF_rv, SHCXX_rv->data(),
            SHCXX_rv->size());
    }
    {
        // final
        delete SHCXX_rv;
    }
    // splicer end function.get_const_string_ptr_len_bufferify
}

// ----------------------------------------
// Function:  const std::string * getConstStringPtrAlloc +deref(allocatable)+owner(library)
// Requested: c_string_*_result
// Match:     c_string_result
const char * STR_get_const_string_ptr_alloc(void)
{
    // splicer begin function.get_const_string_ptr_alloc
    const std::string * SHCXX_rv = getConstStringPtrAlloc();
    const char * SHC_rv = SHCXX_rv->c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ptr_alloc
}

// ----------------------------------------
// Function:  void getConstStringPtrAlloc
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)+owner(library)
// Requested: c_string_*_result_buf_allocatable
// Match:     c_string_result_buf_allocatable
void STR_get_const_string_ptr_alloc_bufferify(STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_ptr_alloc_bufferify
    const std::string * SHCXX_rv = getConstStringPtrAlloc();
    ShroudStrToArray(DSHF_rv, SHCXX_rv, 0);
    // splicer end function.get_const_string_ptr_alloc_bufferify
}

/**
 * It is the caller's responsibility to release the string
 * created by the C++ library.
 * This is accomplished +owner(caller) which sets idtor.
 * The contents are copied by Fortran so they must outlast
 * the return from the C wrapper.
 */
// ----------------------------------------
// Function:  const std::string * getConstStringPtrOwnsAlloc +deref(allocatable)+owner(caller)
// Requested: c_string_*_result
// Match:     c_string_result
const char * STR_get_const_string_ptr_owns_alloc(void)
{
    // splicer begin function.get_const_string_ptr_owns_alloc
    const std::string * SHCXX_rv = getConstStringPtrOwnsAlloc();
    const char * SHC_rv = SHCXX_rv->c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ptr_owns_alloc
}

/**
 * It is the caller's responsibility to release the string
 * created by the C++ library.
 * This is accomplished +owner(caller) which sets idtor.
 * The contents are copied by Fortran so they must outlast
 * the return from the C wrapper.
 */
// ----------------------------------------
// Function:  void getConstStringPtrOwnsAlloc
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * SHF_rv +context(DSHF_rv)+deref(allocatable)+intent(out)+owner(caller)
// Requested: c_string_*_result_buf_allocatable
// Match:     c_string_result_buf_allocatable
void STR_get_const_string_ptr_owns_alloc_bufferify(
    STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_ptr_owns_alloc_bufferify
    const std::string * SHCXX_rv = getConstStringPtrOwnsAlloc();
    ShroudStrToArray(DSHF_rv, SHCXX_rv, 2);
    // splicer end function.get_const_string_ptr_owns_alloc_bufferify
}

/**
 * Similar to getConstStringPtrOwnsAlloc, but uses pattern to release memory.
 */
// ----------------------------------------
// Function:  const std::string * getConstStringPtrOwnsAllocPattern +deref(allocatable)+free_pattern(C_string_free)+owner(caller)
// Requested: c_string_*_result
// Match:     c_string_result
const char * STR_get_const_string_ptr_owns_alloc_pattern(void)
{
    // splicer begin function.get_const_string_ptr_owns_alloc_pattern
    const std::string * SHCXX_rv = getConstStringPtrOwnsAllocPattern();
    const char * SHC_rv = SHCXX_rv->c_str();
    return SHC_rv;
    // splicer end function.get_const_string_ptr_owns_alloc_pattern
}

/**
 * Similar to getConstStringPtrOwnsAlloc, but uses pattern to release memory.
 */
// ----------------------------------------
// Function:  void getConstStringPtrOwnsAllocPattern
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * SHF_rv +context(DSHF_rv)+deref(allocatable)+free_pattern(C_string_free)+intent(out)+owner(caller)
// Requested: c_string_*_result_buf_allocatable
// Match:     c_string_result_buf_allocatable
void STR_get_const_string_ptr_owns_alloc_pattern_bufferify(
    STR_SHROUD_array *DSHF_rv)
{
    // splicer begin function.get_const_string_ptr_owns_alloc_pattern_bufferify
    const std::string * SHCXX_rv = getConstStringPtrOwnsAllocPattern();
    ShroudStrToArray(DSHF_rv, SHCXX_rv, 3);
    // splicer end function.get_const_string_ptr_owns_alloc_pattern_bufferify
}

/**
 * \brief Accept a const string reference
 *
 * Save contents of arg1.
 * arg1 is assumed to be intent(IN) since it is const
 * Will copy in.
 */
// ----------------------------------------
// Function:  void acceptStringConstReference
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string & arg1 +intent(in)
// Requested: c_string_&_in
// Match:     c_string_in
void STR_accept_string_const_reference(const char * arg1)
{
    // splicer begin function.accept_string_const_reference
    const std::string SHCXX_arg1(arg1);
    acceptStringConstReference(SHCXX_arg1);
    // splicer end function.accept_string_const_reference
}

/**
 * \brief Accept a const string reference
 *
 * Save contents of arg1.
 * arg1 is assumed to be intent(IN) since it is const
 * Will copy in.
 */
// ----------------------------------------
// Function:  void acceptStringConstReference
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string & arg1 +intent(in)+len_trim(Larg1)
// Requested: c_string_&_in_buf
// Match:     c_string_in_buf
void STR_accept_string_const_reference_bufferify(const char * arg1,
    int Larg1)
{
    // splicer begin function.accept_string_const_reference_bufferify
    const std::string SHCXX_arg1(arg1, Larg1);
    acceptStringConstReference(SHCXX_arg1);
    // splicer end function.accept_string_const_reference_bufferify
}

/**
 * \brief Accept a string reference
 *
 * Set out to a constant string.
 * arg1 is intent(OUT)
 * Must copy out.
 */
// ----------------------------------------
// Function:  void acceptStringReferenceOut
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & arg1 +intent(out)
// Requested: c_string_&_out
// Match:     c_string_out
void STR_accept_string_reference_out(char * arg1)
{
    // splicer begin function.accept_string_reference_out
    std::string SHCXX_arg1;
    acceptStringReferenceOut(SHCXX_arg1);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.accept_string_reference_out
}

/**
 * \brief Accept a string reference
 *
 * Set out to a constant string.
 * arg1 is intent(OUT)
 * Must copy out.
 */
// ----------------------------------------
// Function:  void acceptStringReferenceOut
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & arg1 +intent(out)+len(Narg1)
// Requested: c_string_&_out_buf
// Match:     c_string_out_buf
void STR_accept_string_reference_out_bufferify(char * arg1, int Narg1)
{
    // splicer begin function.accept_string_reference_out_bufferify
    std::string SHCXX_arg1;
    acceptStringReferenceOut(SHCXX_arg1);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.accept_string_reference_out_bufferify
}

/**
 * \brief Accept a string reference
 *
 * Append "dog" to the end of arg1.
 * arg1 is assumed to be intent(INOUT)
 * Must copy in and copy out.
 */
// ----------------------------------------
// Function:  void acceptStringReference
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & arg1 +intent(inout)
// Requested: c_string_&_inout
// Match:     c_string_inout
// start STR_accept_string_reference
void STR_accept_string_reference(char * arg1)
{
    // splicer begin function.accept_string_reference
    std::string SHCXX_arg1(arg1);
    acceptStringReference(SHCXX_arg1);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.accept_string_reference
}
// end STR_accept_string_reference

/**
 * \brief Accept a string reference
 *
 * Append "dog" to the end of arg1.
 * arg1 is assumed to be intent(INOUT)
 * Must copy in and copy out.
 */
// ----------------------------------------
// Function:  void acceptStringReference
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & arg1 +intent(inout)+len(Narg1)+len_trim(Larg1)
// Requested: c_string_&_inout_buf
// Match:     c_string_inout_buf
// start STR_accept_string_reference_bufferify
void STR_accept_string_reference_bufferify(char * arg1, int Larg1,
    int Narg1)
{
    // splicer begin function.accept_string_reference_bufferify
    std::string SHCXX_arg1(arg1, Larg1);
    acceptStringReference(SHCXX_arg1);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.accept_string_reference_bufferify
}
// end STR_accept_string_reference_bufferify

/**
 * \brief Accept a const string pointer - intent(in)
 *
 */
// ----------------------------------------
// Function:  void acceptStringPointerConst
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * arg1 +intent(in)
// Requested: c_string_*_in
// Match:     c_string_in
void STR_accept_string_pointer_const(const char * arg1)
{
    // splicer begin function.accept_string_pointer_const
    const std::string SHCXX_arg1(arg1);
    acceptStringPointerConst(&SHCXX_arg1);
    // splicer end function.accept_string_pointer_const
}

/**
 * \brief Accept a const string pointer - intent(in)
 *
 */
// ----------------------------------------
// Function:  void acceptStringPointerConst
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  const std::string * arg1 +intent(in)+len_trim(Larg1)
// Requested: c_string_*_in_buf
// Match:     c_string_in_buf
void STR_accept_string_pointer_const_bufferify(const char * arg1,
    int Larg1)
{
    // splicer begin function.accept_string_pointer_const_bufferify
    const std::string SHCXX_arg1(arg1, Larg1);
    acceptStringPointerConst(&SHCXX_arg1);
    // splicer end function.accept_string_pointer_const_bufferify
}

/**
 * \brief Accept a string pointer - intent(inout)
 *
 */
// ----------------------------------------
// Function:  void acceptStringPointer
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(inout)
// Requested: c_string_*_inout
// Match:     c_string_inout
void STR_accept_string_pointer(char * arg1)
{
    // splicer begin function.accept_string_pointer
    std::string SHCXX_arg1(arg1);
    acceptStringPointer(&SHCXX_arg1);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.accept_string_pointer
}

/**
 * \brief Accept a string pointer - intent(inout)
 *
 */
// ----------------------------------------
// Function:  void acceptStringPointer
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(inout)+len(Narg1)+len_trim(Larg1)
// Requested: c_string_*_inout_buf
// Match:     c_string_inout_buf
void STR_accept_string_pointer_bufferify(char * arg1, int Larg1,
    int Narg1)
{
    // splicer begin function.accept_string_pointer_bufferify
    std::string SHCXX_arg1(arg1, Larg1);
    acceptStringPointer(&SHCXX_arg1);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.accept_string_pointer_bufferify
}

/**
 * \brief Accept a string pointer - intent(out)
 *
 * Return global_str.
 */
// ----------------------------------------
// Function:  void fetchStringPointer
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(out)
// Requested: c_string_*_out
// Match:     c_string_out
void STR_fetch_string_pointer(char * arg1)
{
    // splicer begin function.fetch_string_pointer
    std::string SHCXX_arg1;
    fetchStringPointer(&SHCXX_arg1);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.fetch_string_pointer
}

/**
 * \brief Accept a string pointer - intent(out)
 *
 * Return global_str.
 */
// ----------------------------------------
// Function:  void fetchStringPointer
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(out)+len(Narg1)
// Requested: c_string_*_out_buf
// Match:     c_string_out_buf
void STR_fetch_string_pointer_bufferify(char * arg1, int Narg1)
{
    // splicer begin function.fetch_string_pointer_bufferify
    std::string SHCXX_arg1;
    fetchStringPointer(&SHCXX_arg1);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.fetch_string_pointer_bufferify
}

/**
 * \brief Accept a string pointer - intent(inout)
 *
 * Test return tuple with two arguments.
 * Must rename argument to nlen to avoid conflict with intrinsic len.
 */
// ----------------------------------------
// Function:  void acceptStringPointerLen
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(inout)
// Requested: c_string_*_inout
// Match:     c_string_inout
// ----------------------------------------
// Argument:  int * nlen +intent(out)
// Requested: c_native_*_out
// Match:     c_default
void STR_accept_string_pointer_len(char * arg1, int * nlen)
{
    // splicer begin function.accept_string_pointer_len
    std::string SHCXX_arg1(arg1);
    acceptStringPointerLen(&SHCXX_arg1, nlen);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.accept_string_pointer_len
}

/**
 * \brief Accept a string pointer - intent(inout)
 *
 * Test return tuple with two arguments.
 * Must rename argument to nlen to avoid conflict with intrinsic len.
 */
// ----------------------------------------
// Function:  void acceptStringPointerLen
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(inout)+len(Narg1)+len_trim(Larg1)
// Requested: c_string_*_inout_buf
// Match:     c_string_inout_buf
// ----------------------------------------
// Argument:  int * nlen +intent(out)
// Requested: c_native_*_out_buf
// Match:     c_default
void STR_accept_string_pointer_len_bufferify(char * arg1, int Larg1,
    int Narg1, int * nlen)
{
    // splicer begin function.accept_string_pointer_len_bufferify
    std::string SHCXX_arg1(arg1, Larg1);
    acceptStringPointerLen(&SHCXX_arg1, nlen);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.accept_string_pointer_len_bufferify
}

/**
 * \brief Accept a string pointer - intent(out)
 *
 * Return global_str.
 * Test return tuple with two arguments.
 * Must rename argument to nlen to avoid conflict with intrinsic len.
 */
// ----------------------------------------
// Function:  void fetchStringPointerLen
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(out)
// Requested: c_string_*_out
// Match:     c_string_out
// ----------------------------------------
// Argument:  int * nlen +intent(out)
// Requested: c_native_*_out
// Match:     c_default
void STR_fetch_string_pointer_len(char * arg1, int * nlen)
{
    // splicer begin function.fetch_string_pointer_len
    std::string SHCXX_arg1;
    fetchStringPointerLen(&SHCXX_arg1, nlen);
    strcpy(arg1, SHCXX_arg1.c_str());
    // splicer end function.fetch_string_pointer_len
}

/**
 * \brief Accept a string pointer - intent(out)
 *
 * Return global_str.
 * Test return tuple with two arguments.
 * Must rename argument to nlen to avoid conflict with intrinsic len.
 */
// ----------------------------------------
// Function:  void fetchStringPointerLen
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  std::string * arg1 +intent(out)+len(Narg1)
// Requested: c_string_*_out_buf
// Match:     c_string_out_buf
// ----------------------------------------
// Argument:  int * nlen +intent(out)
// Requested: c_native_*_out_buf
// Match:     c_default
void STR_fetch_string_pointer_len_bufferify(char * arg1, int Narg1,
    int * nlen)
{
    // splicer begin function.fetch_string_pointer_len_bufferify
    std::string SHCXX_arg1;
    fetchStringPointerLen(&SHCXX_arg1, nlen);
    ShroudStrCopy(arg1, Narg1, SHCXX_arg1.data(), SHCXX_arg1.size());
    // splicer end function.fetch_string_pointer_len_bufferify
}

// ----------------------------------------
// Function:  void explicit1
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * name +intent(in)+len_trim(AAlen)
// Requested: c_char_*_in
// Match:     c_default
void STR_explicit1(char * name)
{
    // splicer begin function.explicit1
    explicit1(name);
    // splicer end function.explicit1
}

// ----------------------------------------
// Function:  void explicit2
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * name +intent(out)+len(AAtrim)
// Requested: c_char_*_out
// Match:     c_default
void STR_explicit2(char * name)
{
    // splicer begin function.explicit2
    explicit2(name);
    // splicer end function.explicit2
}

// ----------------------------------------
// Function:  void explicit2
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * name +intent(out)+len(AAtrim)
// Exact:     c_char_*_out_buf
void STR_explicit2_bufferify(char * name, int AAtrim)
{
    // splicer begin function.explicit2_bufferify
    explicit2(name);
    ShroudStrBlankFill(name, AAtrim);
    // splicer end function.explicit2_bufferify
}

/**
 * \brief return a char argument (non-pointer), extern "C"
 *
 */
// ----------------------------------------
// Function:  void CreturnChar
// Requested: c_void_scalar_result_buf
// Match:     c_default
// ----------------------------------------
// Argument:  char * SHF_rv +intent(out)+len(NSHF_rv)
// Exact:     c_char_scalar_result_buf
void STR_creturn_char_bufferify(char * SHF_rv, int NSHF_rv)
{
    // splicer begin function.creturn_char_bufferify
    char SHC_rv = CreturnChar();
    std::memset(SHF_rv, ' ', NSHF_rv);
    SHF_rv[0] = SHC_rv;
    // splicer end function.creturn_char_bufferify
}

/**
 * \brief strcpy like behavior
 *
 * dest is marked intent(OUT) to override the intent(INOUT) default
 * This avoid a copy-in on dest.
 * extern "C"
 */
// ----------------------------------------
// Function:  void CpassCharPtr
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  char * dest +intent(out)+len(Ndest)
// Exact:     c_char_*_out_buf
// ----------------------------------------
// Argument:  const char * src +intent(in)
// Requested: c_char_*_in
// Match:     c_default
void STR_cpass_char_ptr_bufferify(char * dest, int Ndest,
    const char * src)
{
    // splicer begin function.cpass_char_ptr_bufferify
    CpassCharPtr(dest, src);
    ShroudStrBlankFill(dest, Ndest);
    // splicer end function.cpass_char_ptr_bufferify
}

// ----------------------------------------
// Function:  void PostDeclare
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  int * count +intent(in)+rank(1)
// Requested: c_native_*_in
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & name +intent(inout)
// Requested: c_string_&_inout
// Match:     c_string_inout
void STR_post_declare(int * count, char * name)
{
    // splicer begin function.post_declare
    std::string SHCXX_name(name);
    PostDeclare(count, SHCXX_name);
    strcpy(name, SHCXX_name.c_str());
    // splicer end function.post_declare
}

// ----------------------------------------
// Function:  void PostDeclare
// Requested: c
// Match:     c_default
// ----------------------------------------
// Argument:  int * count +intent(in)+rank(1)
// Requested: c_native_*_in_buf
// Match:     c_default
// ----------------------------------------
// Argument:  std::string & name +intent(inout)+len(Nname)+len_trim(Lname)
// Requested: c_string_&_inout_buf
// Match:     c_string_inout_buf
void STR_post_declare_bufferify(int * count, char * name, int Lname,
    int Nname)
{
    // splicer begin function.post_declare_bufferify
    std::string SHCXX_name(name, Lname);
    PostDeclare(count, SHCXX_name);
    ShroudStrCopy(name, Nname, SHCXX_name.data(), SHCXX_name.size());
    // splicer end function.post_declare_bufferify
}

// start release allocated memory
// Release library allocated memory.
void STR_SHROUD_memory_destructor(STR_SHROUD_capsule_data *cap)
{
    void *ptr = cap->addr;
    switch (cap->idtor) {
    case 0:   // --none--
    {
        // Nothing to delete
        break;
    }
    case 1:   // new_string
    {
        std::string *cxx_ptr = reinterpret_cast<std::string *>(ptr);
        delete cxx_ptr;
        break;
    }
    case 2:   // std::string
    {
        std::string *cxx_ptr = reinterpret_cast<std::string *>(ptr);
        delete cxx_ptr;
        break;
    }
    case 3:   // C_string_free
    {
        // Used with +free_pattern(C_string_free)
        std::string *cxx_ptr = reinterpret_cast<std::string *>(ptr);
        delete cxx_ptr;

        break;
    }
    default:
    {
        // Unexpected case in destructor
        break;
    }
    }
    cap->addr = nullptr;
    cap->idtor = 0;  // avoid deleting again
}
// end release allocated memory

}  // extern "C"
